'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ulid = require('ulid');

var _require = require('../model'),
    createEntryMixin = _require.createEntryMixin;

var _require2 = require('.'),
    withField = _require2.withField;

var createManyRelation = function createManyRelation(_ref) {
  var QuerySetConstructor = _ref.QuerySetConstructor,
      relation = _ref.relation,
      pk = _ref.pk;

  var ManyRelation = function (_QuerySetConstructor) {
    (0, _inherits3.default)(ManyRelation, _QuerySetConstructor);

    function ManyRelation(_ref2) {
      var parent = _ref2.parent;
      (0, _classCallCheck3.default)(this, ManyRelation);

      var _this = (0, _possibleConstructorReturn3.default)(this, (ManyRelation.__proto__ || Object.getPrototypeOf(ManyRelation)).call(this, { QuerySetConstructor: QuerySetConstructor, parent: parent }));

      _this.relation = relation;
      _this.pk = pk;
      return _this;
    }

    (0, _createClass3.default)(ManyRelation, [{
      key: 'add',
      value: function add(entry) {
        return entry.update((0, _defineProperty3.default)({}, this.relation.pkName, this.pk));
      }
    }]);
    return ManyRelation;
  }(QuerySetConstructor);

  return new ManyRelation({ parent: relation.model.objects.filter((0, _defineProperty3.default)({}, relation.pkName, pk)) });
};

var withRelationField = function withRelationField(_ref3) {
  var model = _ref3.model,
      relation = _ref3.relation,
      name = _ref3.name;
  return createEntryMixin(function (_ref4) {
    var Base = _ref4.Base;
    return function (_Base) {
      (0, _inherits3.default)(_class, _Base);

      function _class() {
        (0, _classCallCheck3.default)(this, _class);
        return (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
      }

      (0, _createClass3.default)(_class, [{
        key: relation.fieldName,
        set: function set(entry) {
          entry[name].add(this);
        },
        get: function get() {
          return model.objects.get({ pk: this[relation.pkName] });
        }
      }]);
      return _class;
    }(Base);
  });
};

var withMany = function withMany(name, _ref5) {
  var _ref5$model = _ref5.model,
      model = _ref5$model === undefined ? null : _ref5$model,
      _ref5$relatedName = _ref5.relatedName,
      relatedName = _ref5$relatedName === undefined ? null : _ref5$relatedName;

  var relation = {
    model: model,
    fieldName: relatedName,
    pkName: relatedName ? '_' + relatedName + '_pk' : '_many_' + name + '_pk_' + ulid()
  };

  relation.model.inject(withField(relation.pkName));

  return createEntryMixin(function (_ref6) {
    var Base = _ref6.Base,
        setup = _ref6.setup;

    var QuerySetConstructor = setup.get('QuerySetConstructor');

    if (relation.fieldName) {
      relation.model.inject(withRelationField({ model: setup.get('model'), name: name, relation: relation }));
    }

    return function (_Base2) {
      (0, _inherits3.default)(_class2, _Base2);

      function _class2() {
        (0, _classCallCheck3.default)(this, _class2);
        return (0, _possibleConstructorReturn3.default)(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).apply(this, arguments));
      }

      (0, _createClass3.default)(_class2, [{
        key: name,
        get: function get() {
          return createManyRelation({ QuerySetConstructor: QuerySetConstructor, relation: relation, pk: this.pk });
        }
      }]);
      return _class2;
    }(Base);
  });
};

module.exports = {
  withMany: withMany
};
