'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFilterPredicate = function createFilterPredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] === expression[key];
    });
  };
};

var getFilterPredicate = function getFilterPredicate(expression) {
  return typeof expression === 'function' ? expression : createFilterPredicate(expression);
};

var QuerySet = function () {
  function QuerySet(_ref) {
    var _ref$parent = _ref.parent,
        parent = _ref$parent === undefined ? null : _ref$parent,
        _ref$predicate = _ref.predicate,
        predicate = _ref$predicate === undefined ? null : _ref$predicate,
        _ref$QuerySetConstruc = _ref.QuerySetConstructor,
        QuerySetConstructor = _ref$QuerySetConstruc === undefined ? QuerySet : _ref$QuerySetConstruc;
    (0, _classCallCheck3.default)(this, QuerySet);

    this.parent = parent;
    this.predicate = predicate;
    this.QuerySetConstructor = QuerySetConstructor;
  }

  (0, _createClass3.default)(QuerySet, [{
    key: 'validate',
    value: function validate(entry) {
      return !this.predicate || this.predicate(entry);
    }
  }, {
    key: 'entries',
    value: _regenerator2.default.mark(function entries() {
      var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, entry;

      return _regenerator2.default.wrap(function entries$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 3;
              _iterator = this.parent.entries()[Symbol.iterator]();

            case 5:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context.next = 13;
                break;
              }

              entry = _step.value;

              if (!this.validate(entry)) {
                _context.next = 10;
                break;
              }

              _context.next = 10;
              return entry;

            case 10:
              _iteratorNormalCompletion = true;
              _context.next = 5;
              break;

            case 13:
              _context.next = 19;
              break;

            case 15:
              _context.prev = 15;
              _context.t0 = _context['catch'](3);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 19:
              _context.prev = 19;
              _context.prev = 20;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 22:
              _context.prev = 22;

              if (!_didIteratorError) {
                _context.next = 25;
                break;
              }

              throw _iteratorError;

            case 25:
              return _context.finish(22);

            case 26:
              return _context.finish(19);

            case 27:
            case 'end':
              return _context.stop();
          }
        }
      }, entries, this, [[3, 15, 19, 27], [20,, 22, 26]]);
    })
  }, {
    key: 'filter',
    value: function filter(expression) {
      return new this.QuerySetConstructor({
        parent: this,
        predicate: getFilterPredicate(expression)
      });
    }
  }, {
    key: 'map',
    value: function map(transform) {
      var res = [];

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = this.entries()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var entry = _step2.value;

          res.push(transform(entry));
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return res;
    }
  }, {
    key: 'first',
    value: function first() {
      return this.entries().next().value;
    }
  }, {
    key: 'get',
    value: function get(expression) {
      return this.filter(expression).first();
    }
  }, {
    key: 'length',
    get: function get() {
      return this.map(function (entry) {
        return entry;
      }).length;
    }
  }]);
  return QuerySet;
}();

module.exports = {
  QuerySet: QuerySet
};
