'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Watcher = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isComponent = function isComponent(el) {
  return !!el && !!el.type && !!el.type.prototype && el.type.prototype instanceof _react.Component;
};

var Watcher = exports.Watcher = function (_Component) {
  _inherits(Watcher, _Component);

  function Watcher() {
    _classCallCheck(this, Watcher);

    return _possibleConstructorReturn(this, (Watcher.__proto__ || Object.getPrototypeOf(Watcher)).apply(this, arguments));
  }

  _createClass(Watcher, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.subscriptions = this.props.sources ? this.props.sources.map(function (source) {
        return _this2.subscribeTo(source);
      }) : [];
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscriptions.forEach(function (subscription) {
        return subscription.remove();
      });
      this.subscriptions = null;
    }
  }, {
    key: 'subscribeTo',
    value: function subscribeTo(source) {
      var _this3 = this;

      return source.emitter.changed(function () {
        return _this3.forceUpdate();
      });
    }
  }, {
    key: 'cloneChildren',
    value: function cloneChildren(el, _ref) {
      var _this4 = this;

      var _ref$children = _ref.children,
          children = _ref$children === undefined ? null : _ref$children;

      return children && _react2.default.Children.count(children) > 0 && !isComponent(el) ? _react2.default.Children.map(children, function (child) {
        return _this4.cloneElement(child);
      }) : children;
    }
  }, {
    key: 'cloneElement',
    value: function cloneElement(el) {
      var children = this.cloneChildren(el, el.props);

      return _react2.default.cloneElement(el, el.props, children);
    }
  }, {
    key: 'render',
    value: function render() {
      var childrenCount = _react2.default.Children.count(this.props.children);

      if (childrenCount !== 1) throw new Watcher.BadChildrenCount(childrenCount);

      return this.cloneElement(_react2.default.Children.only(this.props.children));
    }
  }]);

  return Watcher;
}(_react.Component);

Watcher.propTypes = {
  sources: _react2.default.PropTypes.array.isRequired,
  children: _react2.default.PropTypes.element.isRequired
};

Watcher.BadChildrenCount = function WatcherBadChildrenCount(childrenCount) {
  Object.assign(this, {
    name: 'BadChildrenCount',
    message: 'Watcher accepts only one child. Received : ' + childrenCount
  });
};

Watcher.BadSourceType = function WatcherBadSourceType(name) {
  Object.assign(this, {
    name: 'BadSourceType',
    message: 'Watcher source not valid (bad type) : \'' + name + '\''
  });
};

